var NAVTREE =
[
  [ "The Parametric Pseudo-Manifold (PPS) Library", "index.html", [
    [ "The PPS Library Documentation", "index.html", null ],
    [ "Related Pages", "pages.html", [
      [ "Introduction", "intro.html", null ],
      [ "Installing and compiling the library", "install.html", null ],
      [ "The PPS class API", "api.html", null ],
      [ "The generic mesh API", "mesh.html", null ],
      [ "Defining geometry", "geometry.html", null ],
      [ "A concrete class for building a PPS", "concrete.html", null ],
      [ "Sample code and examples", "example.html", null ],
      [ "License", "lic.html", null ],
      [ "Acknowledgements", "ack.html", null ]
    ] ],
    [ "Modules", "modules.html", [
      [ "Namespace dcel.", "group__DCELNameSpace.html", null ],
      [ "Namespace offlib.", "group__OFFLIBNameSpace.html", null ],
      [ "Namespace pps.", "group__PPSNameSpace.html", null ],
      [ "Namespace ppsfrompnt.", "group__PPSFROMPNTNameSpace.html", null ]
    ] ],
    [ "Class List", "annotated.html", [
      [ "pps::Bezier", "classpps_1_1Bezier.html", null ],
      [ "dcel::Edge< VAttrib, FAttrib, EAttrib, HAttrib >", "classdcel_1_1Edge.html", null ],
      [ "dcel::Face< VAttrib, FAttrib, EAttrib, HAttrib >", "classdcel_1_1Face.html", null ],
      [ "ppsfrompnt::FaceAttribute", "classppsfrompnt_1_1FaceAttribute.html", null ],
      [ "dcel::Halfedge< VAttrib, FAttrib, EAttrib, HAttrib >", "classdcel_1_1Halfedge.html", null ],
      [ "ppsfrompnt::HalfedgeAttribute", "classppsfrompnt_1_1HalfedgeAttribute.html", null ],
      [ "offlib::Lexer", "classofflib_1_1Lexer.html", null ],
      [ "pps::LUdcmp", "classpps_1_1LUdcmp.html", null ],
      [ "ppsfrompnt::PNTriangle", "classppsfrompnt_1_1PNTriangle.html", null ],
      [ "pps::PPS< Mesh >", "classpps_1_1PPS.html", null ],
      [ "ppsfrompnt::PPSfromPNT", "classppsfrompnt_1_1PPSfromPNT.html", null ],
      [ "pps::PPSsampler< Mesh >", "classpps_1_1PPSsampler.html", null ],
      [ "offlib::Reader", "classofflib_1_1Reader.html", null ],
      [ "dcel::Surface< VAttrib, FAttrib, EAttrib, HAttrib >", "classdcel_1_1Surface.html", null ],
      [ "dcel::Vertex< VAttrib, FAttrib, EAttrib, HAttrib >", "classdcel_1_1Vertex.html", null ],
      [ "ppsfrompnt::VertexAttribute", "classppsfrompnt_1_1VertexAttribute.html", null ],
      [ "offlib::Writer", "classofflib_1_1Writer.html", null ]
    ] ],
    [ "Class Index", "classes.html", null ],
    [ "Class Hierarchy", "hierarchy.html", [
      [ "pps::Bezier", "classpps_1_1Bezier.html", null ],
      [ "dcel::Edge< VAttrib, FAttrib, EAttrib, HAttrib >", "classdcel_1_1Edge.html", null ],
      [ "dcel::Face< VAttrib, FAttrib, EAttrib, HAttrib >", "classdcel_1_1Face.html", null ],
      [ "ppsfrompnt::FaceAttribute", "classppsfrompnt_1_1FaceAttribute.html", null ],
      [ "dcel::Halfedge< VAttrib, FAttrib, EAttrib, HAttrib >", "classdcel_1_1Halfedge.html", null ],
      [ "ppsfrompnt::HalfedgeAttribute", "classppsfrompnt_1_1HalfedgeAttribute.html", null ],
      [ "offlib::Lexer", "classofflib_1_1Lexer.html", null ],
      [ "pps::LUdcmp", "classpps_1_1LUdcmp.html", null ],
      [ "ppsfrompnt::PNTriangle", "classppsfrompnt_1_1PNTriangle.html", null ],
      [ "pps::PPS< Mesh >", "classpps_1_1PPS.html", [
        [ "ppsfrompnt::PPSfromPNT", "classppsfrompnt_1_1PPSfromPNT.html", null ]
      ] ],
      [ "pps::PPS< dcel::Surface< VertexAttribute, FaceAttribute, int, HalfedgeAttribute > >", "classpps_1_1PPS.html", null ],
      [ "pps::PPSsampler< Mesh >", "classpps_1_1PPSsampler.html", null ],
      [ "offlib::Reader", "classofflib_1_1Reader.html", null ],
      [ "dcel::Surface< VAttrib, FAttrib, EAttrib, HAttrib >", "classdcel_1_1Surface.html", null ],
      [ "dcel::Surface< VertexAttribute, FaceAttribute, int, HalfedgeAttribute >", "classdcel_1_1Surface.html", null ],
      [ "dcel::Vertex< VAttrib, FAttrib, EAttrib, HAttrib >", "classdcel_1_1Vertex.html", null ],
      [ "ppsfrompnt::VertexAttribute", "classppsfrompnt_1_1VertexAttribute.html", null ],
      [ "offlib::Writer", "classofflib_1_1Writer.html", null ]
    ] ],
    [ "Class Members", "functions.html", null ],
    [ "Namespace List", "namespaces.html", [
      [ "dcel", "namespacedcel.html", null ],
      [ "offlib", "namespaceofflib.html", null ],
      [ "pps", "namespacepps.html", null ],
      [ "ppsfrompnt", "namespaceppsfrompnt.html", null ]
    ] ],
    [ "File List", "files.html", [
      [ "bezier.cpp", "bezier_8cpp.html", null ],
      [ "bezier.h", "bezier_8h.html", null ],
      [ "edge.h", "edge_8h.html", null ],
      [ "face.h", "face_8h.html", null ],
      [ "face_attribute.h", "face__attribute_8h.html", null ],
      [ "halfedge.h", "halfedge_8h.html", null ],
      [ "halfedge_attribute.cpp", "halfedge__attribute_8cpp.html", null ],
      [ "halfedge_attribute.h", "halfedge__attribute_8h.html", null ],
      [ "lexer.cpp", "lexer_8cpp.html", null ],
      [ "lexer.h", "lexer_8h.html", null ],
      [ "ludcmp.cpp", "ludcmp_8cpp.html", null ],
      [ "ludcmp.h", "ludcmp_8h.html", null ],
      [ "mainpage.dxy", null, null ],
      [ "pntriangle.cpp", "pntriangle_8cpp.html", null ],
      [ "pntriangle.h", "pntriangle_8h.html", null ],
      [ "pps.h", "pps_8h.html", null ],
      [ "ppsfrompnt.cpp", "ppsfrompnt_8cpp.html", null ],
      [ "ppsfrompnt.h", "ppsfrompnt_8h.html", null ],
      [ "ppssampler.h", "ppssampler_8h.html", null ],
      [ "reader.cpp", "reader_8cpp.html", null ],
      [ "reader.h", "reader_8h.html", null ],
      [ "sampler.cpp", "sampler_8cpp.html", null ],
      [ "sections.dxy", null, null ],
      [ "surface.h", "surface_8h.html", null ],
      [ "vertex.h", "vertex_8h.html", null ],
      [ "vertex_attribute.h", "vertex__attribute_8h.html", null ],
      [ "writer.cpp", "writer_8cpp.html", null ],
      [ "writer.h", "writer_8h.html", null ]
    ] ],
    [ "File Members", "globals.html", null ]
  ] ]
];

function createIndent(o,domNode,node,level)
{
  if (node.parentNode && node.parentNode.parentNode)
  {
    createIndent(o,domNode,node.parentNode,level+1);
  }
  var imgNode = document.createElement("img");
  if (level==0 && node.childrenData)
  {
    node.plus_img = imgNode;
    node.expandToggle = document.createElement("a");
    node.expandToggle.href = "javascript:void(0)";
    node.expandToggle.onclick = function() 
    {
      if (node.expanded) 
      {
        $(node.getChildrenUL()).slideUp("fast");
        if (node.isLast)
        {
          node.plus_img.src = node.relpath+"ftv2plastnode.png";
        }
        else
        {
          node.plus_img.src = node.relpath+"ftv2pnode.png";
        }
        node.expanded = false;
      } 
      else 
      {
        expandNode(o, node, false);
      }
    }
    node.expandToggle.appendChild(imgNode);
    domNode.appendChild(node.expandToggle);
  }
  else
  {
    domNode.appendChild(imgNode);
  }
  if (level==0)
  {
    if (node.isLast)
    {
      if (node.childrenData)
      {
        imgNode.src = node.relpath+"ftv2plastnode.png";
      }
      else
      {
        imgNode.src = node.relpath+"ftv2lastnode.png";
        domNode.appendChild(imgNode);
      }
    }
    else
    {
      if (node.childrenData)
      {
        imgNode.src = node.relpath+"ftv2pnode.png";
      }
      else
      {
        imgNode.src = node.relpath+"ftv2node.png";
        domNode.appendChild(imgNode);
      }
    }
  }
  else
  {
    if (node.isLast)
    {
      imgNode.src = node.relpath+"ftv2blank.png";
    }
    else
    {
      imgNode.src = node.relpath+"ftv2vertline.png";
    }
  }
  imgNode.border = "0";
}

function newNode(o, po, text, link, childrenData, lastNode)
{
  var node = new Object();
  node.children = Array();
  node.childrenData = childrenData;
  node.depth = po.depth + 1;
  node.relpath = po.relpath;
  node.isLast = lastNode;

  node.li = document.createElement("li");
  po.getChildrenUL().appendChild(node.li);
  node.parentNode = po;

  node.itemDiv = document.createElement("div");
  node.itemDiv.className = "item";

  node.labelSpan = document.createElement("span");
  node.labelSpan.className = "label";

  createIndent(o,node.itemDiv,node,0);
  node.itemDiv.appendChild(node.labelSpan);
  node.li.appendChild(node.itemDiv);

  var a = document.createElement("a");
  node.labelSpan.appendChild(a);
  node.label = document.createTextNode(text);
  a.appendChild(node.label);
  if (link) 
  {
    a.href = node.relpath+link;
  } 
  else 
  {
    if (childrenData != null) 
    {
      a.className = "nolink";
      a.href = "javascript:void(0)";
      a.onclick = node.expandToggle.onclick;
      node.expanded = false;
    }
  }

  node.childrenUL = null;
  node.getChildrenUL = function() 
  {
    if (!node.childrenUL) 
    {
      node.childrenUL = document.createElement("ul");
      node.childrenUL.className = "children_ul";
      node.childrenUL.style.display = "none";
      node.li.appendChild(node.childrenUL);
    }
    return node.childrenUL;
  };

  return node;
}

function showRoot()
{
  var headerHeight = $("#top").height();
  var footerHeight = $("#nav-path").height();
  var windowHeight = $(window).height() - headerHeight - footerHeight;
  navtree.scrollTo('#selected',0,{offset:-windowHeight/2});
}

function expandNode(o, node, imm)
{
  if (node.childrenData && !node.expanded) 
  {
    if (!node.childrenVisited) 
    {
      getNode(o, node);
    }
    if (imm)
    {
      $(node.getChildrenUL()).show();
    } 
    else 
    {
      $(node.getChildrenUL()).slideDown("fast",showRoot);
    }
    if (node.isLast)
    {
      node.plus_img.src = node.relpath+"ftv2mlastnode.png";
    }
    else
    {
      node.plus_img.src = node.relpath+"ftv2mnode.png";
    }
    node.expanded = true;
  }
}

function getNode(o, po)
{
  po.childrenVisited = true;
  var l = po.childrenData.length-1;
  for (var i in po.childrenData) 
  {
    var nodeData = po.childrenData[i];
    po.children[i] = newNode(o, po, nodeData[0], nodeData[1], nodeData[2],
        i==l);
  }
}

function findNavTreePage(url, data)
{
  var nodes = data;
  var result = null;
  for (var i in nodes) 
  {
    var d = nodes[i];
    if (d[1] == url) 
    {
      return new Array(i);
    }
    else if (d[2] != null) // array of children
    {
      result = findNavTreePage(url, d[2]);
      if (result != null) 
      {
        return (new Array(i).concat(result));
      }
    }
  }
  return null;
}

function initNavTree(toroot,relpath)
{
  var o = new Object();
  o.toroot = toroot;
  o.node = new Object();
  o.node.li = document.getElementById("nav-tree-contents");
  o.node.childrenData = NAVTREE;
  o.node.children = new Array();
  o.node.childrenUL = document.createElement("ul");
  o.node.getChildrenUL = function() { return o.node.childrenUL; };
  o.node.li.appendChild(o.node.childrenUL);
  o.node.depth = 0;
  o.node.relpath = relpath;

  getNode(o, o.node);

  o.breadcrumbs = findNavTreePage(toroot, NAVTREE);
  if (o.breadcrumbs == null)
  {
    o.breadcrumbs = findNavTreePage("index.html",NAVTREE);
  }
  if (o.breadcrumbs != null && o.breadcrumbs.length>0)
  {
    var p = o.node;
    for (var i in o.breadcrumbs) 
    {
      var j = o.breadcrumbs[i];
      p = p.children[j];
      expandNode(o,p,true);
    }
    p.itemDiv.className = p.itemDiv.className + " selected";
    p.itemDiv.id = "selected";
    $(window).load(showRoot);
  }
}

